import traceback

from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_core.console import Console

from multi_install.config.application_settings import ApplicationSettings


class ApplicationListSettings(ConfigurationModelABC):

    def __init__(self):
        ConfigurationModelABC.__init__(self)

        self._debian_apps = []
        self._red_hat_apps = []

    @property
    def debian_apps(self) -> str:
        return self._debian_apps

    @property
    def redhat_apps(self) -> str:
        return self._debian_apps

    def from_dict(self, settings: dict):
        try:
            
            for app_cfg in settings['Debian']:
                app = ApplicationSettings()
                app.from_dict(app_cfg)
                self._debian_apps.append(app)
                    
            for app_cfg in settings['RedHat']:
                app = ApplicationSettings()
                app.from_dict(app_cfg)
                self._red_hat_apps.append(app)
        except Exception as e:
            Console.error(f'[ ERROR ] [ {__name__} ]: Reading error in {self.__name__} settings')
            Console.error(f'[ EXCEPTION ] [ {__name__} ]: {e} -> {traceback.format_exc()}')
