import os
from cpl_core.application import StartupABC
from cpl_core.configuration import ConfigurationABC
from cpl_core.dependency_injection import ServiceProviderABC, ServiceCollectionABC
from cpl_core.environment import ApplicationEnvironment
from multi_install.abc.menu_service_abc import MenuServiceABC

from multi_install.service.menu_service import MenuService


class Startup(StartupABC):

    def __init__(self):
        StartupABC.__init__(self)

    def configure_configuration(self, configuration: ConfigurationABC, environment: ApplicationEnvironment) -> ConfigurationABC:
        environment.set_working_directory(os.path.dirname(__file__))
        
        configuration.add_json_file('appsettings.json')
        
        return configuration

    def configure_services(self, services: ServiceCollectionABC, environment: ApplicationEnvironment) -> ServiceProviderABC:
        services.add_singleton(MenuServiceABC, MenuService)
        
        return services.build_service_provider()
